//==================================================================
// CMAC   ʃxNg̒ۃNX
// CMAC.java
// 
// Al̃xNg͂藣UIȓʃxNg𐶐
// 
// ʃxNg𐶐
//==================================================================
import java.io.*;
import java.lang.Math;

//==============CMAC NX  
// class CMAC
// public boolean init( int input_dim, int div_i, int tile );
// public boolean initAtEqualSpaces( int input_dim, int div_i, int tile_i );
// public double[] getFeatureVector( double[] x );
// public double[] getOffset();
// public int     getNumOfInput();
// public int     getNumOfOutput();
// public void    report( PrintStream out_st );
// ͂public void init( int div_i, int tile ) 
//   ɂĈŎw肵input_dim ̗vfō\ꂽdouble̔złȂ΂ȂȂB
// IWi̐ݒł́A^C̓_ɂ炵ĔzuB(init(int,int,int))
//   initAtEqualSpaces(int,int,int)pďݒ肷ƃ^C𓙊Ԋuɂ炵zuɂȂ
//==============================================
public class CMAC {
	int max_dim;          // ԓ̓xNg̎
	int[] numOfElements ; // eKwɂʂ̌
	int max_output_dim ;  // o͂ʃxNg̗vf
	                      // (܂numOfElements̑v)
	int[] ElementStartID ;// eKwɂʂ̐擪ʒu
	double[] gain ;       // 
	public double[] output;
	int div ;
	int depth ;
	double[] offset ;
	//-------------------RXgN^
	CMAC() {
		init( 1, 2, 1 );
	}
	//-----------------------------
	public int    getNumOfInput(){ return(max_dim);}
	public int    getNumOfOutput(){ return(max_output_dim);}
	//----------------------------------------------------
	// Create an FunctionApproximator by parsing an input stream
	//----------------------------------------------------
	public boolean init( int input_dim, int div_i, int tile_i ){
		boolean noerror_flag = true ;
		if( input_dim > 0 ){ 
			max_dim = input_dim ;
		}else{ 
			noerror_flag = false;
			max_dim = 1 ;
		}
		if( div_i < 2 ){ 
			noerror_flag = false;
			div = 2;
		}else{ 
			div = div_i ;
		}
		depth = tile_i ;
		numOfElements = new int[depth]; // eKwɂʂ̌
		ElementStartID = new int[depth];// eKwɂʂ̐擪ʒu
		gain = new double[depth]; //
		offset = new double[depth * max_dim ];
		//----------
		int elementsPerDepth = 1;
		max_output_dim = 0;  // o͂ʃxNg̗vf
		for( int j = 0; j < max_dim ; j++ ){
			elementsPerDepth *= div ;
		}
		for( int k = 0; k < depth; k++ ){
			ElementStartID[k] = max_output_dim ;
			numOfElements[k]  = elementsPerDepth ;
			max_output_dim += elementsPerDepth ;
			for( int j = 0; j < max_dim ; j++ ){
				offset[(k*max_dim)+j] = (1.0 / ((double)(div - 1)))*Math.random() ;
			}
		}
		//-----
		double a,b ;
		b = (double)getNumOfOutput(); //numOfElements[depth-1] ;
		for( int k = 0; k < depth; k++ ){
			a = (double)numOfElements[k] ;
			gain[k] = a / b ;
		}
		output            = new double [max_output_dim] ;
		return( noerror_flag );
	}

	//----------------------------------------------------
	public boolean initAtEqualSpaces( int input_dim, int div_i, int tile_i ){
		boolean noerror_flag = true ;
		if( input_dim > 0 ){ 
			max_dim = input_dim ;
		}else{ 
			noerror_flag = false;
			max_dim = 1 ;
		}
		if( div_i < 2 ){ 
			noerror_flag = false;
			div = 2;
		}else{ 
			div = div_i ;
		}
		depth = tile_i ;
		numOfElements = new int[depth]; // eKwɂʂ̌
		ElementStartID = new int[depth];// eKwɂʂ̐擪ʒu
		gain = new double[depth]; //
		offset = new double[depth * max_dim ];
		//----------
		int elementsPerDepth = 1;
		max_output_dim = 0;  // o͂ʃxNg̗vf
		for( int j = 0; j < max_dim ; j++ ){
			elementsPerDepth *= div ;
		}
		for( int k = 0; k < depth; k++ ){
			ElementStartID[k] = max_output_dim ;
			numOfElements[k]  = elementsPerDepth ;
			max_output_dim += elementsPerDepth ;
			for( int j = 0; j < max_dim ; j++ ){
//				offset[(k*max_dim)+j] = (1.0 / ((double)(div - 1)))*Math.random() ;
				offset[(k*max_dim)+j] = (1.0 / ((double)(div - 1)))*((double)k/((double)depth)) ;
			}
		}
		//-----
		double a,b ;
		b = (double)getNumOfOutput(); //numOfElements[depth-1] ;
		for( int k = 0; k < depth; k++ ){
			a = (double)numOfElements[k] ;
			gain[k] = a / b ;
		}
		output            = new double [max_output_dim] ;
		return( noerror_flag );
	}

	//---------------------------------------
	public double[] getFeatureVector( double[] x ){
		//----------
		for( int j = 0; j < max_output_dim ; j++ ){
			output[j] = 0 ;
		}
		//----------
		int hitID = 0 ;
		double tmp ;
		double step ;
		int divpo = 1;
		for( int k = 0; k < depth; k++ ){
			divpo = 1;
			hitID = ElementStartID[k];
			step = 1.0 / ((double)(div-1)) ;
			double tmpx = 0 ;
			for( int j = 0; j < max_dim ; j++ ){
				if( x[j] < 0 ){ 
					x[j] = 0 ;
				}else if( x[j] > 1 ){ 
					x[j] = 1 ;
				}
				tmpx = x[j] + offset[k*max_dim+j];
				hitID += (divpo * ((int)Math.floor(tmpx / step))) ;
				divpo *= div ;
			}
			output[hitID] = gain[k] ; // Ym[h̔
		}

//		System.out.println( "Generated Feature Vector:");
//		for( int k = 0; k < depth; k++ ){
//			for( int j = 0; j < numOfElements[k] ; j++ ){
//				hitID = ElementStartID[k] +j ;
//				System.out.print( output[hitID] + " ") ;
//			}
//			System.out.println( "");
//		}
//		System.out.println( "Total:");
//		for( int j = 0; j < max_output_dim ; j++ ){
//			System.out.print( output[j] + " ") ;
//		}
//		System.out.println( "");
		return( output );
	}

	//--------------------------------------
	public double[] getOffset(){
		return( offset );    // double[depth * max_dim ];
	}
	public boolean setOffset( double[] arry ){
		if( arry.length < offset.length ){ return(false);}
		for( int i = 0; i < depth * max_dim; i++  ){
			offset[i] = arry[i] ;
		}
		return( true );
	}
	public boolean setOffset( int id, double val ){
		if( id > offset.length -1 ){ return(false);}
		if( id < 0 ){ return(false);}
		offset[id] = val ;
		return( true );
	}


	//o͂---------------------------------------------
	public void report( PrintStream out_st ){
		return;
	}
	//==========================================
	public static void main( String args[] ){
		int input_dim;
		int depth_i ;
		int type_i ;
		CMAC fvg = new CMAC();
		//------
		if( args.length < 3 ){
			System.out.println("CMAC <input_dim> <div(>=2)> <depth(>=1)> <x1> <x2> ..." );
			return ;
		}
		input_dim =  Integer.valueOf( args[0] ).intValue() ;
//		System.out.println("input_dim = " + Integer.toString( input_dim ) );
		depth_i =  Integer.valueOf( args[1] ).intValue() ;
//		System.out.println("depth = " + Integer.toString( depth_i ) );
		type_i =  Integer.valueOf( args[2] ).intValue() ;
//		System.out.println("type = " + Integer.toString( type_i ) );
		double[] input = new double[input_dim] ;
		fvg.init( input_dim, depth_i, type_i ); 
		System.out.println("pass 1");
		for( int j = 3; j < args.length ; j++ ){
			input[j-3] = Double.valueOf( args[j] ).doubleValue() ;
		}
		double[] outputptr = fvg.getFeatureVector( input );
		System.out.println( "Generated Feature Vector:");
		for( int j = 0; j < fvg.getNumOfOutput() ; j++ ){
			System.out.print( outputptr[j] + " ") ;
		}
		System.out.println( "");
	}
}
