//====================================================================
// wKvg̃V~[^vOBEBhEtB
// EtherUDPvgRpĖ{vg𐧌䂷B
// PlantSimulatorWindow.javaUDPvgRΉɏC
// 2004.12.26 by H.Kimura
//====================================================================

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.util.*;

import java.applet.Applet;
import java.applet.AudioClip;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.net.URL;
import java.net.MalformedURLException;

// import ENVIRONMENT;
// import ROBOT;   // extends  ENVIRONMENT;

// ڎ撎̘r̖{ς鎩NX "ROBOTmk2"
// import ROBOTmk2;   // extends  ENVIRONMENT;

// ================================================================================
// UDPRoboWinNX
// T[oƂċNCIP|[gւ̃pPbgʐMŃR}hƂ肷邱Ƃ
// vg̏Ԋϑ^vgւ̍só^V̊ϑsB
// ================================================================================
public class UDPRoboWin extends Frame implements ActionListener {
	PLANTCanvas plantCanvas;

	static int numOfArms;    // {̎ڎ撎ɂ邩
	static int portNumber;   // TCP-IP port number

	// --------------------------------------------------
	// RXgN^
	// --------------------------------------------------
	UDPRoboWin(){
		super( "UDPRoboWin" );   // Window Title
		setFont( new Font( "Courier", Font.PLAIN, 12 ) );
		setSize( 400, 240 );

		// Menu, MenuBar
		Menu menu1 = new Menu( "TimeStep" );
		MenuItem t50ms = new MenuItem( "50ms" );
		MenuItem t100ms = new MenuItem( "100ms" );
		MenuItem t200ms = new MenuItem( "200ms" );
		MenuItem t500ms = new MenuItem( "500ms" );
		MenuItem t1sec  = new MenuItem( "1sec" );
		MenuItem quit   = new MenuItem( "quit" );
		menu1.add( t50ms );
		menu1.add( t100ms );
		menu1.add( t200ms );
		menu1.add( t500ms );
		menu1.add( t1sec );
		Menu menu2 = new Menu( "System" );
		menu2.add( quit );
		MenuBar mbar = new MenuBar();
		mbar.add( menu1 );
		mbar.add( menu2 );
		setMenuBar( mbar );

		t50ms.addActionListener( this );
		t100ms.addActionListener( this );
		t200ms.addActionListener( this );
		t500ms.addActionListener( this );
		t1sec.addActionListener( this );
		quit.addActionListener( this );

		//--------------------Plant display initialize
		plantCanvas = new PLANTCanvas( numOfArms, this );
		add( "Center", plantCanvas );
		plantCanvas.start();

	}

	// --------------------------------------------------
	// C֐
	// --------------------------------------------------
	public static void main( String args[] ) {
		if( args.length < 2 ) {
			System.out.println();
			System.out.println( "Please input as below" );
			System.out.println( "  \"UDPRoboWin + <the number of arms> + <TCP-IP port number>\"" );
			System.out.println();
			return ;
		}

		numOfArms = Integer.parseInt( args[0] );
		portNumber = Integer.parseInt( args[1] );
		System.out.println( "The number of arms = " + numOfArms );
		System.out.println( "TCP-IP port number = " + portNumber );
		UDPRoboWin psw = new UDPRoboWin();
		psw.setVisible( true );   // show();
		psw.run();
	}

	// --------------------------------------------------
	// Xbh̏
	// --------------------------------------------------
	public void run() {
		try {
			DatagramSocket socket = new DatagramSocket( portNumber );
			byte[] data = new byte[4096];
			DatagramPacket packet = new DatagramPacket( data, 4096 );
			while( true ) {
				//------------------------------UDP 
				//--------------------
				socket.receive( packet );
				data = packet.getData();
				String message = new String( data, 0, packet.getLength() );
		//		System.out.println( message );
				StringTokenizer st = new StringTokenizer( message );
				String word;
				int messageID = 0;
				String answerMessage = ""; // ԐMbZ[WString
				while( st.hasMoreTokens() ){
					word = st.nextToken();
					if( word.equals("MessageID") ){
						messageID = Integer.valueOf( st.nextToken() ).intValue() ;
					}else if( word.equals("GetInformation") ){
						answerMessage = GetInformation( messageID );
					}else if( word.equals("GetState") ){
						answerMessage = GetState( messageID );
					}else if( word.equals("SetAction") ){
						System.out.println( message );
						plantCanvas.SetAction( message ) ;
						answerMessage = GetState( messageID );
						break ;
					}else if( word.equals("Action") ){
						System.out.println( message );
						plantCanvas.SetAction( message ) ;
						answerMessage = GetAnswerForActionCommand( messageID );
						break ;
					}else if( word.equals("Event") ){
						answerMessage = GetAnswerForEventCommand( messageID );
					}else if( word.equals("quit") ){
						answerMessage = GetAnswerForQuitCommand( messageID );
					}else{
						System.out.println( "UnknownCommand: " + word + " message = "+ message);
					}
				}
				//-------StringoCg֕ϊ
				byte[] data1 = answerMessage.getBytes() ;
				DatagramPacket packet1 = new DatagramPacket( data1, data1.length, packet.getAddress(), packet.getPort() );
				//-------pPbgo
				socket.send( packet1 ) ;
			}
		}catch( IOException e ) {
			System.err.println( "Socket IOException" );
			System.exit( -1 );
		}
	}

	// --------------------------------------------------
	public String GetInformation( int num ){
		StringBuffer strBuf = new StringBuffer("MessageID ");
		strBuf.append( num );
		strBuf.append( " " );
		strBuf.append( plantCanvas.GetInformation() ) ;
		return( strBuf.toString() );
	}
	// --------------------------------------------------
	// NCAgɏԂʒm郁\bh
	// --------------------------------------------------
	public String GetState( int num ){
		StringBuffer strBuf = new StringBuffer("MessageID ");
		strBuf.append( num );
		strBuf.append( " " ).append( plantCanvas.GetState() );
		return( strBuf.toString() );
	}
	public String GetStateReward( int num ){
		StringBuffer strBuf = new StringBuffer("MessageID ");
		strBuf.append( num );
		strBuf.append( " " ).append( plantCanvas.GetState() ).append(" \n");
		strBuf.append( plantCanvas.GetReward() );
		return( strBuf.toString() );
	}

	//---------------------
	public String GetAnswerForActionCommand( int num ){
		StringBuffer strBuf = new StringBuffer("MessageID ");
		strBuf.append( num );
		strBuf.append( " ok.\n" );
		return( strBuf.toString() );
	}
	public String GetAnswerForEventCommand( int num ){
		StringBuffer strBuf = new StringBuffer("MessageID ");
		strBuf.append( num );
		if( plantCanvas.getNewEventOccuredFlag() ){
			strBuf.append( " " ).append( plantCanvas.GetState() ).append(" \n");
			strBuf.append( plantCanvas.GetReward() );
			System.out.println( strBuf.toString() );
		}else{
			strBuf.append( " NotYet.\n" );
		}
		return( strBuf.toString() );
	}
	public String GetAnswerForQuitCommand( int num ){
		StringBuffer strBuf = new StringBuffer("MessageID ");
		strBuf.append( num );
		strBuf.append( " Goodbye." );
		return( strBuf.toString() );
	}

	// GUI EVENT ---------------------------------------------------------------
	public void actionPerformed( ActionEvent e ) {
		if( e.getActionCommand().equals( "100ms" ) ) {
			plantCanvas.setSleepTime( 100 );
		}else if( e.getActionCommand().equals( "50ms" ) ) {
			plantCanvas.setSleepTime( 50 );
		}else if( e.getActionCommand().equals( "200ms" ) ) {
			plantCanvas.setSleepTime( 200 );
		}else if( e.getActionCommand().equals( "500ms" ) ) {
			plantCanvas.setSleepTime( 500 );
		}else if( e.getActionCommand().equals( "1sec" ) ) {
			plantCanvas.setSleepTime( 1000 );
		}else if( e.getActionCommand().equals( "quit" ) ) {
			System.exit( 0 );
		}
	}
}


// ======================================================================
// PLANTCanvasNXBPLANTNXCanvasNXho[WB
// V~[gENVIRONMENTNX(ROBOTNX)PlantSimulator
// NXƂ̊ԂɓAR}h̑MsȂ
// ======================================================================
class PLANTCanvas extends Canvas implements Runnable {
	Thread runner; 
	int SleepTime;
	int numOfArms;
	UDPRoboWin psPtr;

	Font theFont;
	Image offscreenImage;
	Graphics offscreenGraphics;
	int cwidth, cheight;

	// setting parameters for agent
	double state[];
	double act[];
	double reward[];
	double accumulatedReward[];

	ENVIRONMENT Environment;   // = new ROBOT();
	boolean OneStepMode;
	boolean newEventWasOccured ;

	// --------------------------------------------------
	// RXgN^
	// --------------------------------------------------
	PLANTCanvas( int numOfArmsIn, UDPRoboWin psPtrIn ) {
		SleepTime = 50;   // l50msecƂ
		numOfArms = numOfArmsIn;
		psPtr = psPtrIn;
		Environment = new ROBOTmk2( numOfArms );
		act = new double[Environment.GetObservationDimension()] ;
		// state = new double[Environment.GetActionDimension()];
		accumulatedReward = new double[Environment.GetRewardDimension()];
		theFont = new Font( "Courier", Font.PLAIN, 12 );   // "TimesRoman",Font.BOLD,16);
		cwidth = 16;
		cheight = 16;
		OneStepMode = false;   // OneStepMode͐؂Ă
		newEventWasOccured = true ;
	}

	// --------------------------------------------------
	// Xbhs郁\bh "start"
	// --------------------------------------------------
	public void start() {
		if( runner == null ) {
			runner = new Thread( this );
			runner.start();
		}
	}

	// --------------------------------------------------
	// VԂ܂ł̎ԂZbg郁\bh
	// --------------------------------------------------
	public void setSleepTime( int t ) {
		SleepTime = t;
	}

	// --------------------------------------------------
	// Xbh̏
	// --------------------------------------------------
	public void run() {
		while( true ) {
			if( !newEventWasOccured ) {   // Cxgƈꎞ~ԂɂȂ
				repaint(); // moveOneStep();
			}
			try {
				Thread.sleep( SleepTime );
			}catch( InterruptedException e ) {
			}
		}
	}

	// --------------------------------------------------
	// Avbgo͗p\bh
	// --------------------------------------------------
	public void paint( Graphics g ) {
		// offscreen--------------------------------------------------------------
		if( ( cwidth != this.getSize().width ) || ( cheight != this.getSize().height ) ) {
			cwidth = this.getSize().width;
			cheight = this.getSize().height;
			offscreenImage = createImage( this.getSize().width, this.getSize().height );
			offscreenGraphics = offscreenImage.getGraphics();
			offscreenGraphics.setFont( theFont );
			// TSPView display initialize
			AudioClip ac[] = new AudioClip[1];
			Environment.InitDisp( this.getSize().width, this.getSize().height, ac );
		}

		// ŎۂɎڎ撎
		moveOneStep();
		Environment.DispEnvironment( offscreenGraphics );

		// offscreen to DC
		g.drawImage( offscreenImage, 0, 0, this );
	}

	public void update( Graphics g ) {
		paint( g );
	}

	// --------------------------------------------------
	// XbhŎs郁\bh "moveOneStep"
	// --------------------------------------------------
	public synchronized void moveOneStep() {
		reward = Environment.ExecuteAction( act );
		//----------Cxg܂ŕV~
		for( int i= 0; i < Environment.GetRewardDimension(); i++ ){
			accumulatedReward[i] += reward[i] ;
		}
		newEventWasOccured = Environment.isEventOccured();  // CxgtrueԂ
	}

	// --------------------------------------------------
	// ̏Ԃ\bh "GetInformation"
	// --------------------------------------------------
	public synchronized String GetInformation() {
		String logString = "Information\n";
		logString += ( "NumOfStateVariables " + Environment.GetObservationDimension() +"\n" );
		logString += ( "SpecificationOfStateVariables\n" );
		int attr[] = Environment.GetObservationAttribute();
		for( int i = 0; i < Environment.GetObservationDimension(); i++ ) {
			if( attr[i] < 2 ) {
				logString += ( "Range 0  1  Step 0\n" );
			}else{
				logString += ( "Range 0 " + ( attr[i] -1 ) + " Step 1\n" );
			}
		}
		logString += ( "NumOfActionVariables " + Environment.GetActionDimension() +"\n" );
		logString += ( "SpecificationOfActionVariables\n" );
		attr = Environment.GetActionAttribute();
		for( int i = 0; i < Environment.GetActionDimension(); i++ ) {
			if( attr[i] < 2 ) {
				logString += ( "Range 0  1  Step 0\n" );
			}else{
				logString += ( "Range 0 " + ( attr[i]-1 ) + " Step 1\n" );
			}
		}
		logString += ( "NumOfRewardVariables " + Environment.GetRewardDimension() +" \n.\n" );
		return( logString );
	}

	// --------------------------------------------------
	// ̏ԂԂ\bh "GetState"
	// --------------------------------------------------
	public synchronized String GetState() {
		int attr[] = Environment.GetObservationAttribute();
		int si = 0;
		state = Environment.GetObservation();
		String logString = "State" ;
		for( int i = 0; i < Environment.GetObservationDimension(); i++ ){
			if( attr[i] < 2 ){
				logString += ( " " + state[i] );
			}else{
				si = (int) state[i] ;
				logString += ( " " + si );
			}
		}
		logString += " \n" ;
		return( logString );
	}

	// --------------------------------------------------
	// ɑꂽsԂ\bh "GetAction"
	// --------------------------------------------------
	public String GetAction() {
		String logString = "Action";
		for( int i = 0; i < Environment.GetActionDimension(); i++ ) {
			logString += ( " " + act[i] );
		}
		logString += "\n.\n" ;
		return( logString );
	}
	// --------------------------------------------------
	// V݌v̒lԂAV݌ṽJE^lZbg郁\bh 
	// --------------------------------------------------
	public synchronized String GetReward() {
		String logString = "Reward";
		for( int i = 0; i < Environment.GetRewardDimension(); i++ ) {
			logString += ( " " + accumulatedReward[i] );
			accumulatedReward[i] = 0; // V݌v[փZbg
		}
		logString += " \n" ;
		return( logString );
	}

	// --------------------------------------------------
	// ֑si[郁\bh "SetAction"
	// --------------------------------------------------
	public synchronized void SetAction( String s ) {
		StringTokenizer st = new StringTokenizer( s );
		String word;
		while( st.hasMoreTokens() ){
			word = st.nextToken();
			if( word.equals("SetAction")||word.equals("Action") ){
				for( int i = 0; i < Environment.GetActionDimension(); i++ ) {
					if( st.hasMoreTokens() ) {
						word = st.nextToken();
						try {
							act[i] = Double.valueOf( word ).doubleValue();
						}catch( NumberFormatException e ) {
							System.out.println( "Error: NumberFormatException" );
						}
					}
				}
			}
		}
		newEventWasOccured = false ;
		// OneStepModeԑJ
		// if( OneStepMode ) {
		// 	repaint();
		// }
	}
	//-------------------------------------
	public boolean getNewEventOccuredFlag(){return( newEventWasOccured );}

	//-------------------------------------
	public int GetRewardDimension(){return(Environment.GetRewardDimension());} 

}
